//------------------------------------------------------------------------------
//
//  npgdal.h
//
// ANTZ - 3D data viewer with realtime real-world interaction based on NPE.
//
// ANTZ is hosted at http://temporalzone.com and NPE at http://neuralphysics.org
//
// Written in 2010-2011 by Shane Saxon - contact@saxondigital.net
//
// Additional code contributed by: Mark Buchanan and Lucas Erickson.
//
// To the extent possible under law, the author(s) have dedicated all copyright 
// and related and neighboring rights to this software to the public domain
// worldwide. This software is distributed without any warranty.
//
// Released under the CC0 license, which is GPL compatible.
//
// You should have received a copy of the CC0 Public Domain Dedication along
// with this software (license file named COPYING.txt). If not, see
// http://creativecommons.org/publicdomain/zero/1.0/
//
//------------------------------------------------------------------------------

#ifndef NPGDAL_H_
#define NPGDAL_H_


#include "../../npdata.h"


//------------------------------------------------------------------------------
void npInitGDAL (void* dataRef);
void npCloseGDAL (void* dataRef);

// these functions wrap the standard C file methods on Linux, MSW and OSX
// opens or creates the file in the specified mode "rb+" read/write binary..
FILE* npOpenGDAL (const char* fileName, const char* mode, void* dataRef);

FILE* npGDALNew (const char* fileName, const char* mode, void* dataRef);

FILE* npGDALDialog (const char* fileName, int dialogType, void* dataRef);

// if not saved then opens SaveAs dialog before reseting app
void npGDALClose (void* dataRef);

// wrappers for fread(), fwrite() and rewind()
//void npReadFile (void* writeBuffer, int wordSize, int size, void* dataRef);
int npReadGDAL (void* readBuffer, int elementSize, int elementCount, 
				 FILE* file, void* dataRef);
int npWriteGDAL (const void* str, int wordSize, int size, FILE* file, void* dataRef);

// 
void npSaveGDAL (FILE* file, void* dataRef);

void npImportGDAL (FILE* file, int type, void* dataRef);
void npExportGDAL (FILE* file, void* dataRef);

// file management
void npGetAttribGDAL (int size, void* dataRef);
void npSetAttribGDAL (int size, void* dataRef);

void npTestGDAL (void* fileName, int wordSize, int size, void* dataRef);


#endif